/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.dicommodel.modules;

import cdac.medinfo.sdk.dcm30_04.baselibs.DicomV3Factory;
import cdac.medinfo.sdk.dcm30_04.baselibs.NominalScreenDefinitionSequence;
import cdac.medinfo.sdk.dcm30_04.baselibs.Tag;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITag;

import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidModuleException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ISingleCollection;
import cdac.medinfo.sdk.dcm30_04.utils.SingleCollection;
/**
\* This module is used for Hanging Protocol Environment Module.
*/
public class HangingProtocolEnvironmentModule extends Module
{
	/**
	 * The obj single collection.
	 */
	public static ISingleCollection<ITag> objSingleCollection = null;


	/**
	 * Creates instance of HangingProtocolEnvironmentModule
	 * 
	 * @param objIDataSet the obj i data set
	 */
	public HangingProtocolEnvironmentModule(IDataSet objIDataSet)
	{
		super(objIDataSet);
	}

	static
	{
		objSingleCollection = new SingleCollection<ITag>();
		objSingleCollection.add(new Tag(0x0072, 0x0102));
		objSingleCollection.add(new Tag(0x0072, 0x0100));

	}

	/**
	 * This method validates each Attribute in the Module according to the Type
	 * of the Attribute.Attributes are of 5 types.
	 * Type 1,Type 2 are Mandatory:
	 * Mandatory Attributes have to present in the Module.
	 * Type 1C,2C are Conditional:
	 * Conditional Attributes' presence depend on a condition.
	 * If the condition is satisfied the Attribute has to be present.
	 * Type 3 are Optional
	 * Optional Attributes can be added as and when required.
	 * 
	 * @return true, if validate module
	 * 
	 * @throws InvalidModuleException - If validation of Module fails
	 */

	public boolean validateModule()throws InvalidModuleException
	{

		try
		{
			/*
			 * Validation Rules for Mandatory Elements
			 */
			if(!isPresent(0x0072, 0x0100))
				throw new MandatoryMissingException("Missing Mandatory Element 0072,0100");
			if(!isPresent(0x0072, 0x0102))
				throw new MandatoryMissingException("Missing Mandatory Element 0072,0102");

		}
		catch(MandatoryMissingException mme)
		{
			if(DicomConfig.createInstance().isLoggingOn())
				DicomLogger.getLogger().log(mme.getMessage());

			
				throw new InvalidModuleException(this.getClass().getSimpleName(),mme);

		}
		return true;
	}
	/**
	 * Retrieves pre-initialized object of NominalScreenDefinitionSequence
	 * @return NominalScreenDefinitionSequence - NominalScreenDefinitionSequence
	 */
	public NominalScreenDefinitionSequence getNominalScreenDefinitionSequence()
	{
		NominalScreenDefinitionSequence objNominalScreenDefinitionSequence = (NominalScreenDefinitionSequence)getDicomValue(0x0072, 0x0102);
		if(objNominalScreenDefinitionSequence == null)
		{
			/*
			 * If the sequence object is not present in the DataSet, a new sequence object is created and
			 * the TransferSyntax and DictionaryReader is set into it as it is set in the Module. This ensures that 
			 * the DataElements getting added in the DataSet follow the same TransferSyntax and use the same
			 * DictionaryReader object as that of the module.
			 */
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			objNominalScreenDefinitionSequence = (NominalScreenDefinitionSequence)objDicomV3Factory.createSequence(0x0072, 0x0102, objITransferSyntax, objIDictionaryReader);
			
			// This will add Data Element of SQ to the DataSet.
			addDataElement(0x0072, 0x0102, DicomConstants.DCM_DT_SQ, objNominalScreenDefinitionSequence.getValue());
		}
		return objNominalScreenDefinitionSequence;	
	}
	
	/**
	 * Sets Positive integer indicating the number of screens for which this Hanging Protocol is intended.
	 * @param shNumberOfScreens short value of Number of Screens
	 */
	public void setNumberOfScreens(short shNumberOfScreens)
	{
		/* Accept the Number of Screens of type US.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		addDataElement(0x0072, 0x0100, DicomConstants.DCM_DT_US,shNumberOfScreens);
	}

	/**
	 * Retrieves Positive integer indicating the number of screens for which this Hanging Protocol is intended.
	 * @return short - short value of Number of Screens
	 */
	public short getNumberOfScreens()
	{
		Object objValue = getValue(0x0072, 0x0100);
		if(objValue != null)
			return Short.parseShort(objValue.toString());

		return DicomConstants.DCM_NO_VALUE;
	}
	/**
	 * This method returns the custom collection containing the list of DataElements belonging to the CT
	 * Image Module specified by DICOM Standard.
	 * 
	 * @return collection - custom collection containing the list of DataElements belonging to the CT Image Module
	 */
	public ISingleCollection<ITag> getVectorOfKeys()
	{
		return objSingleCollection;
	}
}
